package com.ldodds.foaf.thinlet.load;

import java.io.*;
import java.awt.*;

import com.hp.hpl.mesa.rdf.jena.mem.ModelMem;
import com.hp.hpl.mesa.rdf.jena.model.*;
import com.hp.hpl.mesa.rdf.jena.vocabulary.*;
import com.hp.hpl.mesa.rdf.jena.common.SelectorImpl;
import com.hp.hpl.mesa.rdf.jena.common.ResIteratorImpl;
import com.hp.hpl.jena.util.ResIteratorWrapper;

import com.ldodds.foaf.thinlet.*;
//import com.ldodds.foaf.thinlet.model.*;

/**
 *
 * @author pwilson
 * @todo before ever loading a file, we should see if any of the current fields are filled, and
 * if the user wants to discard or save them.
 * wow, that sounds like an iteration i have no idea how to perform.
 */
public class FoafFileLoader
{

  public void load()
  {
    InputStream in = null;

    try
    {
      FileDialog fileDialog = new FileDialog(Services.getFrame(), "Open FOAF file...", FileDialog.LOAD);

      fileDialog.show();

      if (fileDialog.getFile() == null)
        return;

      Model model = new ModelMem();

      FileReader fr = new FileReader(fileDialog.getDirectory()+fileDialog.getFile());

      model.read(fr, "");

      Object editBox = null;

      // load main Person
      StmtIterator iter = model.listStatements();
      while (iter.hasNext())
      {
        Statement stmt      = iter.next();         // get next statement
        Resource  subject   = stmt.getSubject();   // get the subject
        Property  predicate = stmt.getPredicate(); // get the predicate
        RDFNode   object    = stmt.getObject();    // get the object

        // this is my best go at getting the correct Person's details - using the dc:creator term
        // as detailed http://www.semanticplanet.com/library/DescribingRdfDocuments
        if ("creator".equals(predicate.getLocalName()) && subject.toString().length()==0 )
        {
          Resource res = (Resource)object;

          editBox = Services.getComponentManager().find("foaf:title");
          Services.getComponentManager().setString(editBox, "text", mGetProperty(res, FOAF.title));

          editBox = Services.getComponentManager().find("foaf:firstName");
          Services.getComponentManager().setString(editBox, "text", mGetProperty(res, FOAF.firstName));

          editBox = Services.getComponentManager().find("foaf:surname");
          Services.getComponentManager().setString(editBox, "text", mGetProperty(res, FOAF.surname));

          editBox = Services.getComponentManager().find("foaf:nick");
          Services.getComponentManager().setString(editBox, "text", mGetProperty(res, FOAF.nick));

          editBox = Services.getComponentManager().find("foaf:mbox");
          String mbox = mGetProperty(res, FOAF.mbox);
          if (mbox!=null && mbox.startsWith("mailto:"))
            mbox = mbox.substring(7);
          Services.getComponentManager().setString(editBox, "text", mbox);

          editBox = Services.getComponentManager().find("foaf:homepage");
          Services.getComponentManager().setString(editBox, "text", mGetProperty(res, FOAF.homepage));

          editBox = Services.getComponentManager().find("foaf:depiction");
          Services.getComponentManager().setString(editBox, "text", mGetProperty(res, FOAF.depiction));

          editBox = Services.getComponentManager().find("foaf:schoolHomepage");
          Services.getComponentManager().setString(editBox, "text", mGetProperty(res, FOAF.schoolHomepage));

          editBox = Services.getComponentManager().find("foaf:workplaceHomepage");
          Services.getComponentManager().setString(editBox, "text", mGetProperty(res, FOAF.workplaceHomepage));

        }
      } //end load Person

      // load friends
      Selector selector = new SelectorImpl(null, FOAF.knows, (RDFNode)null);
      iter = model.listStatements(selector);
      while (iter.hasNext())
      {
        Resource friend = iter.next().getResource();

        if ( (mGetProperty(friend, FOAF.firstName)!=null) && (mGetProperty(friend, FOAF.surname)!=null) )
        {
          editBox = Services.getComponentManager().find("foaf:friend_firstName");
          Services.getComponentManager().setString(editBox, "text", mGetProperty(friend, FOAF.firstName));

          editBox = Services.getComponentManager().find("foaf:friend_surname");
          Services.getComponentManager().setString(editBox, "text", mGetProperty(friend, FOAF.surname));
        }
        else if (mGetProperty(friend, FOAF.name)!=null)
        {
          String[] names = mGetProperty(friend, FOAF.name).split(" ");

          editBox = Services.getComponentManager().find("foaf:friend_firstName");
          Services.getComponentManager().setString(editBox, "text", names[0]);

          editBox = Services.getComponentManager().find("foaf:friend_surname");
          Services.getComponentManager().setString(editBox, "text", names[names.length-1]);
        }

        if (mGetProperty(friend, FOAF.mbox_sha1sum)!=null)
        {
          editBox = Services.getComponentManager().find("foaf:friend_mboxsha1sum");
          Services.getComponentManager().setString(editBox, "text", mGetProperty(friend, FOAF.mbox_sha1sum));
        }
        else if (mGetProperty(friend, FOAF.mbox)!=null)
        {
          editBox = Services.getComponentManager().find("foaf:friend_mbox");
          Services.getComponentManager().setString(editBox, "text", mGetProperty(friend, FOAF.mbox));
        }

        if (mGetProperty(friend, FOAF.nick)!=null)
        {
          editBox = Services.getComponentManager().find("foaf:friend_nick");
          Services.getComponentManager().setString(editBox, "text", mGetProperty(friend, FOAF.nick));
        }

        if (mGetProperty(friend, RDFS.seeAlso)!=null)
        {          
          editBox = Services.getComponentManager().find("rdfs:friend_seeAlso");
          Services.getComponentManager().setString(editBox, "text", mGetProperty(friend, RDFS.seeAlso));
        }

        new FriendBuilder().addFriendToTable(false);

      }

		}
    catch (Exception e)
		{
			e.printStackTrace();
		}
		finally
		{
			if (in != null)
			{
				try
        {
          in.close();
        }
        catch (Exception e) {}
			}
		}
  }


  // urk, this works, but feels like a hack.
  // relying on multiple try-catch statements? bleurgh.
  private static String mGetProperty(Resource r, Property p)
  {
    Statement pStatement;

    try
    {
      pStatement = r.getProperty(p);
    }
    catch (RDFException e1)
    {
      return null;
    }

    try
    {
      if (r.hasProperty(p))
      {
        try
        {
          return pStatement.getString();
        }
        catch (RDFException e2)
        {
          return pStatement.getResource().toString();
          // and what happens if that throws an error too? can it? (we already know it's not a literal)
        }
      }
    }
    catch (RDFException e3)
    {
      return null;
    }

    return null;
  }

}