package com.ldodds.foaf.thinlet.load;

import java.io.*;
import java.awt.*;

import com.ldodds.foaf.thinlet.*;
import com.ldodds.foaf.thinlet.model.*;

/**
 * 
 * @author pwilson
 */
public class VCardLoader
{
  public void loadFriend()
  {
    BufferedReader in = null;
    try
    {
      FileDialog fileDialog = new FileDialog(Services.getFrame(), "Open vCard for a friend...", FileDialog.LOAD);
      fileDialog.show();

      if (fileDialog.getFile() == null)
      {
        return;
      }
      
      in = new BufferedReader(new FileReader(new File(fileDialog.getDirectory(), fileDialog.getFile())));

      String line;
      while ((line = in.readLine())!=null)
      {
        // we pluck only the first and last elements of any full name
        // this looks hideously inefficient but took five seconds.
        // @todo check code, check to see if already data in the fields we're about to write over
        String[] broken = line.split(":");
        if ("FN".equals(broken[0]))          
        {
          String[] aName = broken[1].trim().split(" ");
          Object editBox = Services.getComponentManager().find("foaf:friend_firstName");
          Services.getComponentManager().setString(editBox, "text", aName[0]);

          int aLength = aName.length;
          String sName = aName[aLength-1];
          editBox = Services.getComponentManager().find("foaf:friend_surname");
          Services.getComponentManager().setString(editBox, "text", sName);
        }
        if ("EMAIL;PREF;INTERNET".equals(broken[0]))          
        {
          Object firstName = Services.getComponentManager().find("foaf:friend_mbox");
          Services.getComponentManager().setString(firstName, "text", broken[1].trim());
        }
         
      }

		} 
    catch (Exception e)
		{
			e.printStackTrace();
		}
		finally
		{
			if (in != null)
			{
				try 
        { 
          in.close(); 
        } 
        catch (Exception e) {}
			}
		}	
  }

}